new;
cls;

output file=anadgp4b.out reset;
nfile="dgp4b";

open f1=^nfile for read;
z=readr(f1,rowsf(f1));
call close(f1);
names=getname(nfile);
makevars(z,0,names);
dgpnum=mergevar(names[1]);
montec=mergevar(names[2]);
observ=mergevar(names[3]);
y=mergevar(names[4]);
x1=mergevar(names[5]);
x2=mergevar(names[6]);
d=mergevar(names[7]);
data=mergevar(names[4:7]);

"
************************** Informacion del fichero *****************************
";
ntot=rows(data);
montecs=montec[rows(montec)];
n=ntot/montecs;
"Nombre:";;print$ nfile;
"Numero de registros:";;ntot;
"Numero de repeticiones:";;montec[rows(montec)];
"Observaciones por repeticion:";;(ntot/montec[rows(montec)]);

data2an=data[1:n,.];
y2an=y[1:n];

"
*************************** Estadisticos descriptivos **************************
NOTA: Estos estadisticos se refieren a la primera muestra de tamanyo n
";
dat2print={ "COUNT(y)","X1","X2","BIN(d)" };
dat2print=dat2print~
            meanc(data2an)~
            diag(vcx(data2an))~
            maxc(data2an)~
            minc(data2an);
"
Variable            Media         Varianza           Maximo           Minimo
-----------------------------------------------------------------------------";
call printfmt(dat2print,0~1~1~1~1);

print;
"Analisis de la variable count";
"-----------------------------";
"Ratio varianza/media:";;vcx(y2an)/meanc(y2an);
"Porcentaje de ceros:";;sumc(y2an.==0)/n;
"Porcentaje predicho por una Poisson:";;exp(-meanc(y2an));
"Ratio obs./pred.:";;(sumc(y2an.==0)/n)/exp(-meanc(y2an));

"
*************************** Tabla de frecuencias *******************************
";

v={ 0,1,2,3,4,5,999 };
freqs=counts(y2an,v);
l=meanc(y2an);
freq_esp=(l^v[1:6]).*exp(-l)./(v[1:6]!);
freq_esp=freq_esp|(1-sumc(freq_esp));
dat2print={ "Y=0","Y=1","Y=2","Y=3","Y=4","Y=5","Y>5" };
dat2print=dat2print~
            freqs~
            freqs/n~
            freq_esp;
"
        COUNT  F.Absoluta       F.Relativa       F.Esperada
--------------------------------------------------------------";
call printfmt(dat2print,0~1~1~1);
output off;
end;
